import 'dart:async';
import 'dart:io' show Platform;
import 'dart:math' as math;
import 'dart:convert';
import 'package:beacons_plugin/beacons_plugin.dart';
import 'package:blindnavigation/Strings/Common_Strings.dart';
import 'package:flutter/material.dart';
import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:firebase_core/firebase_core.dart';
import 'Strings/Common_Strings.dart';
import 'package:firebase_database/firebase_database.dart';
import 'package:speech_to_text/speech_to_text.dart' as stt;
import 'package:audioplayers/audio_cache.dart';
import 'package:flutter_compass/flutter_compass.dart';

class Homepage extends StatefulWidget {
  @override
  _HomepageState createState() => _HomepageState();
}

class _HomepageState extends State<Homepage> {
  String _beaconResult = 'Not Scanned Yet.';
  int _nrMessaggesReceived = 0;
  var isRunning = false;
  var entry;
  var exit;
  var finalPath = [];

  final player = AudioCache();

  bool _hasPermissions = false;
  CompassEvent _lastRead;
  DateTime _lastReadAt;

  var _directionk = 0.5;

  stt.SpeechToText _speech;
  bool _isListening = false;
  String _text = 'Start recording to get directions';
  String _text2 = ' ';
  double _confidence = 1.0;

  var blockedstates = '0';
  var blockedlocation;

  final StreamController<String> beaconEventsController =
      StreamController<String>.broadcast();
  dynamic data;

  final TextEditingController _startController = TextEditingController();
  final TextEditingController _endController = TextEditingController();

  Future<dynamic> getData() async {
    final firestoreInstance = FirebaseFirestore.instance;
    final fb = FirebaseDatabase.instance;
    final ref = fb.reference();
    ref.child("blocked").once().then((DataSnapshot data) {
      print(data.value);
      setState(() {
        blockedstates = data.value.toString();
      });
    });

    firestoreInstance
        .collection("data")
        // .where("address.country", isEqualTo: "USA")
        .snapshots()
        .listen((result) {
      result.docs.forEach((result) {
        setState(() {
          data = result.data();
        });
      });
    });
  }
  // print(data)

  @override
  void initState() {
    super.initState();
    initPlatformState();
    _speech = stt.SpeechToText();
    getData();
  }

  @override
  void dispose() {
    beaconEventsController.close();
    _startController.dispose();
    _endController.dispose();
    super.dispose();
  }

  // Widget _buildManualReader() {
  //   return Padding(
  //     padding: const EdgeInsets.all(16.0),
  //     child: Row(
  //       children: <Widget>[
  //         ElevatedButton(
  //           child: Text('Read Value'),
  //           onPressed: () async {
  //             final CompassEvent tmp = await FlutterCompass.events.first;
  //             setState(() {
  //               _lastRead = tmp;
  //               _lastReadAt = DateTime.now();
  //             });
  //           },
  //         ),
  //         Expanded(
  //           child: Padding(
  //             padding: const EdgeInsets.all(8.0),
  //             child: Column(
  //               crossAxisAlignment: CrossAxisAlignment.start,
  //               children: <Widget>[
  //                 Text(
  //                   '$_lastRead',
  //                   style: Theme.of(context).textTheme.caption,
  //                 ),
  //                 Text(
  //                   '$_lastReadAt',
  //                   style: Theme.of(context).textTheme.caption,
  //                 ),
  //               ],
  //             ),
  //           ),
  //         ),
  //       ],
  //     ),
  //   );
  // }

  _buildCompass() {
    StreamBuilder<CompassEvent>(
      stream: FlutterCompass.events,
      builder: (context, snapshot) {
        double direction = snapshot.data.heading;

        setState(() {
          _directionk:
          direction;
        });
      },
    );
  }

  void stream() {
    var stream = decoder('Websocket.dart');
    encoder(stream);
  }

  void checkcommand(val) {
    if (val == 'a2b') {
      setState(() {
        entry = 'a';
        exit = 'b';
      });
    } else if (val == 'a2c') {
      setState(() {
        entry = 'a';
        exit = 'c';
      });
    } else if (val == 'b2a') {
      setState(() {
        entry = 'b';
        exit = 'a';
      });
    } else if (val == 'b2c') {
      setState(() {
        entry = 'b';
        exit = 'c';
      });
    } else if (val == 'c2a') {
      setState(() {
        entry = 'c';
        exit = 'a';
      });
    } else if (val == 'c2b') {
      setState(() {
        entry = 'c';
        exit = 'b';
      });
    } else {}
  }

  void _listen() async {
    if (!_isListening) {
      bool available = await _speech.initialize(
        onStatus: (val) => print('onStatus: $val'),
        onError: (val) => print('onError: $val'),
      );
      if (available) {
        setState(() => _isListening = true);
        _speech.listen(
          onResult: (val) => setState(() {
            _text2 = val.recognizedWords;
            print(_text2);
            checkcommand(_text2);
            if (val.hasConfidenceRating && val.confidence > 0) {
              _confidence = val.confidence;
              print(_confidence);
            }
          }),
        );
      }
    } else {
      setState(() => _isListening = false);
      _speech.stop();
    }
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
    if (Platform.isAndroid) {
      //Prominent disclosure
      await BeaconsPlugin.setDisclosureDialogMessage(
          title: "Need Location Permission",
          message: "This app collects location data to work with beacons.");

      //Only in case, you want the dialog to be shown again. By Default, dialog will never be shown if permissions are granted.
      //await BeaconsPlugin.clearDisclosureDialogShowFlag(false);
    }

    BeaconsPlugin.listenToBeacons(beaconEventsController);

    await BeaconsPlugin.addRegion(
        "BeaconType1", "909c3cf9-fc5c-4841-b695-380958a51a5a");
    await BeaconsPlugin.addRegion(
        "BeaconType2", "6a84c716-0f2a-1ce9-f210-6a63bd873dd9");

    beaconEventsController.stream.listen(
        (jsonData) {
          Map<String, dynamic> data = json.decode(jsonData);
          if (data.isNotEmpty) {
            setState(() {
              _beaconResult = data['uuid'];
              _nrMessaggesReceived++;
            });
          }
        },
        onDone: () {},
        onError: (error) {
          print("Error: $error");
        });

    //Send 'true' to run in background
    await BeaconsPlugin.runInBackground(true);

    if (Platform.isAndroid) {
      BeaconsPlugin.channel.setMethodCallHandler((call) async {
        if (call.method == 'scannerReady') {
          await BeaconsPlugin.startMonitoring();
          setState(() {
            isRunning = true;
          });
        }
      });
    } else if (Platform.isIOS) {
      await BeaconsPlugin.startMonitoring();
      setState(() {
        isRunning = true;
      });
    }

    if (!mounted) return;
  }

  encription(data, key) {
    var keygen = keygenerator(key);
    var streamcontroller = scramble(data, keygen);
    var output = streamcontroller.broadcast();

    return output;
  }

  keygenerator(val) {
    var cons = 10000;
    var pi = cons * math.sin(180 / cons);
    var strpi = pi.toString();
    var arrpi = [];
    arrpi[0] = strpi[val];
    arrpi[1] = strpi[val + 1];
    arrpi[2] = strpi[val + 2];

    return arrpi;
  }

  scramble(data, key) {
    var shuffled = data.shuffle(key);
    return shuffled;
  }

  checknull(data) {
    try {
      var newdata = blockedstates;
      if (newdata == '1') {
        return 'obstacle ahead';
      } else {
        return 'no obstacle ahead';
      }
      // return newdata;
    } catch (e) {
      print(data);
      return 'no transmission';
    }
  }

  mapfunc(uuid) {
    if (uuid == StringConst.a) {
      return 1;
    } else if (uuid == StringConst.ab) {
      return 2;
    } else if (uuid == StringConst.b) {
      return 3;
    } else if (uuid == StringConst.bc) {
      return 4;
    } else if (uuid == StringConst.c) {
      return 5;
    } else if (uuid == StringConst.ac) {
      return 6;
    } else {
      return 0;
    }
  }

  mapfuncstr(uuid) {
    if (uuid == StringConst.a) {
      setState(() {
        blockedlocation = 'a';
      });
    } else if (uuid == StringConst.ab) {
      setState(() {
        blockedlocation = 'ab';
      });
    } else if (uuid == StringConst.b) {
      setState(() {
        blockedlocation = 'b';
      });
    } else if (uuid == StringConst.bc) {
      setState(() {
        blockedlocation = 'bc';
      });
    } else if (uuid == StringConst.c) {
      setState(() {
        blockedlocation = 'c';
      });
    } else if (uuid == StringConst.ac) {
      setState(() {
        blockedlocation = 'ac';
      });
    } else {
      setState(() {
        blockedlocation = 'a';
      });
    }
  }

  selectroute(start, end, uuid) {
    // print('########################');
    // print(start);
    // print(end);
    mapfuncstr(uuid);
    if (start == 'a') {
      if (end == 'b') {
        if (uuid == StringConst.a) {
          return 7;
        } else if (uuid == StringConst.ab) {
          return 8;
        } else if (uuid == StringConst.b) {
          return 9;
        } else {
          var k = mapfunc(uuid);
          return k;
        }
      } else if (end == 'c') {
        if (uuid == StringConst.a) {
          return 10;
        } else if (uuid == StringConst.ac) {
          return 11;
        } else if (uuid == StringConst.c) {
          return 12;
        } else {
          var k = mapfunc(uuid);
          return k;
        }
      } else {
        return 1;
      }
    } else if (start == 'b') {
      if (end == 'a') {
        if (uuid == StringConst.b) {
          return 13;
        } else if (uuid == StringConst.ab) {
          return 14;
        } else if (uuid == StringConst.a) {
          return 15;
        } else {
          var k = mapfunc(uuid);
          return k;
        }
      } else if (end == 'c') {
        if (uuid == StringConst.b) {
          return 16;
        } else if (uuid == StringConst.bc) {
          return 17;
        } else if (uuid == StringConst.c) {
          return 18;
        } else {
          var k = mapfunc(uuid);
          return k;
        }
      } else {
        return 3;
      }
    } else if (start == 'c') {
      if (end == 'b') {
        if (uuid == StringConst.c) {
          return 22;
        } else if (uuid == StringConst.bc) {
          return 23;
        } else if (uuid == StringConst.b) {
          return 24;
        } else {
          var k = mapfunc(uuid);
          return k;
        }
      } else if (end == 'a') {
        if (uuid == StringConst.c) {
          return 19;
        } else if (uuid == StringConst.ac) {
          return 20;
        } else if (uuid == StringConst.a) {
          return 21;
        } else {
          var k = mapfunc(uuid);
          return k;
        }
      } else {
        return 5;
      }
    } else {
      var k = mapfunc(uuid);
      return k;
    }
  }

  obstacle(data, start, end) {
    try {
      var obstacle_present = blockedstates;
      var location = blockedlocation;
      var val = pathgenerator(start, end);
      if (obstacle_present == '1') {
        if (val.contains(location)) {
          if (location == 'ab') {
            if (start == 'a') {
              player.play('o1.mp3');
              return 'turn right and move till ac, '
                  'turn left at ac and move till bc, '
                  'turn left at bc and move till b';
            } else {
              player.play('o2.mp3');
              return 'move till bc, '
                  'turn right at bc and move till ac, '
                  'turn right at ac and move till a ';
            }
          } else if (location == 'bc') {
            if (start == 'b') {
              player.play('o3.mp3');
              return 'move till ab, '
                  'turn left at ab and move till b, '
                  'turn left at b and move till bc, '
                  'turn left at bc and move till c';
            } else {
              player.play('o4.mp3');
              return 'turn left and move till ac, '
                  'turn right at ac and move till bc, '
                  'turn right at bc and move till b';
            }
          } else {
            if (start == 'c') {
              player.play('o5.mp3');
              return 'turn right and move till bc, '
                  'turn left at bc and move till b, '
                  'turn left at b and move till ab, '
                  'turn left at ab and move till a';
            } else {
              player.play('o6.mp3');
              return 'move till ab, '
                  'turn left at ab and move till b, '
                  'turn left at b and move till bc, '
                  'turn left at bc and move till c';
            }
          }
        } else {
          return gettextdir(val);
        }
      } else {
        return gettextdir(val);
      }
    } catch (e) {
      print(e);
      return 'enter starting and ending locations';
    }
  }

  decoder(data) {
    try {
      Map types = {'String': 1, 'int': 2};
      var arr = [];
      if (data[0].toRadixString(10) == 126 &&
          data.last.toRadixString(10) == 126) {
        data.remove(data[0]);
        data.remove(data.last);
        var sum = data.last;
        data.remove(data.last);
        var type = data.last;
        data.remove(data.last);
        var count = data.last;
        data.remove(data.last);
        var databody = data;
        if (sum == type + count + databody &&
            type == types[data.runtimeType] &&
            count == data.length) {
          dynamic stream = data;
        }
      }
    } catch (e) {
      print(e);
    }
  }

  encoder(data) {
    Map types = {'String': 1, 'int': 2};
    Map val = {'a': 1, 'b': 2, 'c': 3};
    var type = types['${data.runtimeType}'];
    var temp = [];
    var endval = 126;
    temp.add(endval);
    temp.add(val['${data[0]}']);
    temp.add(val['${data[1]}']);
    var count = temp.length;
    temp.add(count);
    temp.add(type);
    var sum = temp.reduce((a, b) => a + b);
    temp.add(sum);
    temp.add(endval);

    var hexval = [];
    temp.forEach((element) => hexval.add(element.toRadixString(16)));

    dynamic stream = hexval;
  }

  // pathfinder(entry, exit) {
//   var nodes = [
//     'a',
//     'ab',
//     'b',
//     'bc',
//     'c',
//     'ac'
//   ];
//   var links = [
//     [
//       'a',
//       'ab',
//       '1'
//     ],
//     [
//       'ab',
//       'b',
//       '1'
//     ],
//     [
//       'b',
//       'bc',
//       '1'
//     ],
//     [
//       'bc',
//       'c',
//       '1'
//     ],
//     [
//       'c',
//       'ac',
//       '1'
//     ],
//     [
//       'ac',
//       'a',
//       '1'
//     ]
//   ];
//   var entry_lists = [];
//   var entry_lists_extra = [];
//   var exit_lists = [];
//   var exit_lists_extra = [];
//   var path_lengths = [];
//   var status = 0;

//   for (var i = 0; i < links.length; i++) {
//     var a = addlist0(i, entry, links);
//     var b = addlist1(i, exit, links);
//     // print(a);
//     // print(b);
//     if (a.length > 0) {
//       entry_lists.add(a[0]);
//     }
//     if (b.length > 0) {
//       exit_lists.add(b[0]);
//     }
//   }
//   for (var i = 0; i < links.length; i++) {
//     if (entry_lists.length > 0) {
//       var c = addlist1(i, entry_lists[0][0], links);
//       var d = addlist0(i, entry_lists[0][1], links);
//       var e = addlist1(i, exit_lists[0][0], links);
//       var f = addlist0(i, exit_lists[0][1], links);
//       if (c.length > 0) {
//         entry_lists_extra.add(addlist1(i, entry_lists[0][0], links));
//       }
//       if (d.length > 0) {
//         entry_lists_extra.add(addlist0(i, entry_lists[0][1], links));
//       }
//       if (e.length > 0) {
//         exit_lists_extra.add(addlist1(i, exit_lists[0][0], links));
//       }
//       if (f.length > 0) {
//         exit_lists_extra.add(addlist0(i, exit_lists[0][1], links));
//       }
//     }
//   }

//   // print(entry_lists);
//   // print(exit_lists);
//   // print(entry_lists_extra);
//   // print(exit_lists_extra);
//   var listoflists = checksimmilarities(entry_lists_extra, exit_lists_extra);
//   var listofsim = listoflists[0];
//   // print(listofsim);
//   // print(listoflists[1]);

//   var simlnodes = listofsim.where((item) => nodes.contains(item)).toList();
//   // print(simlnodes);

//   var entryexit = [
//     entry,
//     exit
//   ];
//   var entryexitpositions = listoflists[1].where((item) => entryexit.contains(item)).toList();
//   // print(entryexitpositions);

//   var indexlist = [];

//   for (var i = 0; i < simlnodes.length; i++) {
//     indexlist.add(listofsim.indexOf(simlnodes[i]));
//   }

//   // print(indexlist);

//   String a = entry_lists[0][0];

//   return a;
// }

// checksimmilarities(entry_lists_extra, exit_lists_extra) {
//   var flattenList1 = [];
//   entry_lists_extra.forEach((nums) => nums.forEach((number) => number.forEach((item) => flattenList1.add(item))));
//   // print(flattenList1);

//   var flattenList2 = [];
//   exit_lists_extra.forEach((nums) => nums.forEach((number) => number.forEach((item) => flattenList2.add(item))));
//   // print(flattenList2);

//   var list = [];

//   for (var j = 0; j < flattenList1.length; j++) {
//     for (var i = 0; i < flattenList1.length; i++) {
//       var k = flattenList1[j];
//       var e = flattenList2[i];
//       if (k == e) {
//         list.add(k);
//       }
//     }
//   }
//   var combinedlists = flattenList1 + flattenList2;
//   var listoflists = [
//     list,
//     combinedlists
//   ];

//   return listoflists;
// }

// addlist0(i, position, links) {
//   var lists = [];
//   if (links[i][0] == position) {
//     lists.add(links[i]);
//   }

//   return lists;
// }

// addlist1(i, position, links) {
//   var lists = [];
//   if (links[i][1] == position) {
//     lists.add(links[i]);
//   }

//   return lists;
// }

  pathgenerator(entry, exit) {
    Map map_val = {
      'a': ['ab', 'ac'],
      'ab': ['b', 'a'],
      'b': ['ab', 'bc'],
      'bc': ['b', 'c'],
      'c': ['ac', 'bc'],
      'ac': ['a', 'c'],
    };
    finalPath.clear();

    try {
      var entry_paths = map_val[entry];

      finalPath.add(entry);

      check_exit(map_val, entry_paths[0], entry_paths[1], exit);

      print(finalPath);
    } catch (e) {
      print(e);
      return 'enter starting and ending locations';
    }

    // var entry_paths = map_val[entry];
    //
    // finalPath.add(entry);
    //
    // check_exit(map_val,entry_paths[0],entry_paths[1],exit);
    //
    // print(finalPath);
    // var k = '$finalPath';
    // print(k);
    // var s = 'a';

    return finalPath;
  }

  check_exit(map, start, end, exit) {
    var start_val = map[start];
    var end_val = map[end];

    if (start_val.contains(exit)) {
      finalPath.add(start);
      if (exit == start_val[0]) {
        finalPath.add(start_val[0]);
      } else {
        finalPath.add(start_val[1]);
      }
    } else if (end_val.contains(exit)) {
      finalPath.add(end);
      if (exit == end_val[0]) {
        finalPath.add(end_val[0]);
      } else {
        finalPath.add(end_val[1]);
      }
    } else {
      check_exit(map, end_val[0], end_val[1], exit);
    }
  }
  // checkpathnull(entry, exit){
  //   try{
  //     testt(entry, exit);
  //   }catch (e) {
  //     print(e);
  //     return 'enter starting and ending locations';
  //   }
  //
  // }
  //
  // testt(entry, exit){
  //   if(exit == 'b'){
  //     return 's';
  //   }
  //
  // }

  gettextdir(path) {
    var start = path[0];
    var end = path[-1];

    if (start == 'a') {
      if (end == 'b') {
        player.play('n1.mp3');
        return 'turn left and move till ab, '
            'turn right at ab and move till b';
      } else {
        player.play('n2.mp3');
        return 'turn right and move till ac, '
            'turn left at ac and move till c';
      }
    } else if (start == 'b') {
      if (end == 'a') {
        player.play('n3.mp3');
        return 'turn right and move till ab, '
            'turn left at ab and move till a';
      } else {
        player.play('n4.mp3');
        return 'move till bc, '
            'turn left at bc and move till c';
      }
    } else {
      if (end == 'b') {
        player.play('n5.mp3');
        return 'turn right and move till bc, '
            'turn left at bc and move till b';
      } else {
        player.play('n6.mp3');
        return 'turn left and move till ac, '
            'turn right at ac and move till b';
      }
    }
  }

  @override
  Widget build(BuildContext context) {
    double width = MediaQuery.of(context).size.width;
    double height = MediaQuery.of(context).size.height;
    var map_aray = [
      'assets/mapNoPerson2.png',
      'assets/mapStart.png',
      'assets/mapTurnLeft1.png',
      'assets/mapTurnLeft2.png',
      'assets/mapTurnRight1.png',
      'assets/mapTurnRightMid.png',
      'assets/mapTurnRight2.png',
      'assets/ab1.png',
      'assets/ab2.png',
      'assets/ab3.png',
      'assets/ac1.png',
      'assets/ac2.png',
      'assets/ac3.png',
      'assets/ba1.png',
      'assets/ba2.png',
      'assets/ba3.png',
      'assets/bc1.png',
      'assets/bc2.png',
      'assets/bc3.png',
      'assets/ca1.png',
      'assets/ca2.png',
      'assets/ca3.png',
      'assets/cb1.png',
      'assets/cb2.png',
      'assets/cb3.png'
    ];
    // var pathlistval = checkpathnull(entry, exit)??'enter starting and ending locations';
    return WillPopScope(
      onWillPop: () async => false,
      child: Scaffold(
        appBar: AppBar(
          title: const Text('I-Navigator v3'),
        ),
        body: SingleChildScrollView(
          child: Column(
            crossAxisAlignment: CrossAxisAlignment.center,
            mainAxisAlignment: MainAxisAlignment.center,
            children: <Widget>[
              Container(
                height: height / 1.5,
                width: width,
                decoration: BoxDecoration(
                  image: DecorationImage(
                      image: AssetImage(
                          map_aray[selectroute(entry, exit, _beaconResult)]),
                      fit: BoxFit.fill),
                  boxShadow: [
                    BoxShadow(
                      color: Colors.grey.withOpacity(0.5), //color of shadow
                      spreadRadius: 5, //spread radius
                      blurRadius: 7, // blur radius
                      offset: Offset(0, 2), // changes position of shadow
                    ),
                  ],
                ),
                padding: EdgeInsets.symmetric(horizontal: 10.0, vertical: 10.0),
              ),
              Container(
                  alignment: Alignment.center,
                  child: Padding(
                      padding: const EdgeInsets.all(20.0),
                      child: TextField(
                        style: TextStyle(fontSize: 20),
                        controller: _startController,
                        onChanged: (text) {
                          setState(() {
                            entry = text;
                          });
                        },
                        decoration: InputDecoration(
                          // enabledBorder: UnderlineInputBorder(
                          //   borderSide: BorderSide(color: Colors.white),
                          // ),
                          hintText: 'enter starting location',
                          // hintStyle: TextStyle(
                          //     fontSize: 20.0, color: Colors.white54)
                        ),
                      ))),
              Container(
                  alignment: Alignment.center,
                  child: Padding(
                      padding: const EdgeInsets.all(20.0),
                      child: TextField(
                        style: TextStyle(fontSize: 20),
                        controller: _endController,
                        onChanged: (text) {
                          setState(() {
                            exit = text;
                          });
                        },
                        decoration: InputDecoration(
                          // enabledBorder: UnderlineInputBorder(
                          //   borderSide: BorderSide(color: Colors.white),
                          // ),
                          hintText: 'enter destination',
                          // hintStyle: TextStyle(
                          //     fontSize: 20.0, color: Colors.white54)
                        ),
                      ))),
              Container(
                alignment: Alignment.center,
                child: Padding(
                  padding: const EdgeInsets.only(
                    left: 16,
                    top: 40,
                    right: 16,
                    bottom: 16,
                  ),
                  child: Text('$_text2'),
                ),
              ),
              Container(
                alignment: Alignment.center,
                child: Padding(
                  padding: const EdgeInsets.only(
                    left: 16,
                    top: 20,
                    right: 16,
                    bottom: 20,
                  ),
                  child: Text(
                      '${obstacle(data, entry, exit) ?? 'enter locations'}'),
                ),
              ),
              Container(
                alignment: Alignment.center,
                child: Padding(
                  padding: const EdgeInsets.only(
                    left: 16,
                    top: 20,
                    right: 16,
                    bottom: 20,
                  ),
                  child: Text(checknull(data)),
                ),
              ),
              Container(
                alignment: Alignment.center,
                child: Padding(
                  padding: const EdgeInsets.only(
                    left: 16,
                    top: 20,
                    right: 16,
                    bottom: 20,
                  ),
                  child: ElevatedButton(
                    onPressed: () async {
                      if (isRunning) {
                        await BeaconsPlugin.stopMonitoring();
                      } else {
                        initPlatformState();
                        await BeaconsPlugin.startMonitoring();
                      }
                      setState(() {
                        isRunning = !isRunning;
                      });
                    },
                    child: Text(isRunning ? 'Stop Scanning' : 'Start Scanning',
                        style: TextStyle(fontSize: 20)),
                  ),
                ),
              ),
              Container(
                child: FloatingActionButton(
                  onPressed: _listen,
                  child: Icon(_isListening ? Icons.mic : Icons.mic_none),
                ),
              ),
              // _buildCompass(),
              // Builder(builder: (context) {
              //   Container(
              //     child: Transform.rotate(
              //       angle: (_directionk * (math.pi / 180) * -1),
              //       child: Image.asset('assets/compass.jpg'),
              //     ),
              //   );
              // })
              ElevatedButton(
                child: Text('Compass'),
                onPressed: () async {
                  final CompassEvent tmp = await FlutterCompass.events.first;
                  print(tmp.heading);
                  setState(() {
                    _directionk = tmp.heading;
                  });
                },
              ),
              SizedBox(height: 100),
              Container(
                child: Transform.rotate(
                  angle: (_directionk * (math.pi / 180) * -1),
                  child: Image.asset('assets/compass.png'),
                ),
              ),
            ],
          ),
        ),
      ),
    );
  }
}
